<h1 id="accordion">Accordion</h1>
<p>Accordion is a component consisting of vertically stacked sections of content that can be shown or hidden or using trigger buttons, commonly used to reduce the need to scroll when presenting multiple sections of content on a single page.</p>
<p>Accordion conforms to the <a href="https://www.w3.org/WAI/ARIA/apg/patterns/accordion/">W3C WAI-ARIA authoring practices</a>.</p>
<h2 id="set-up">Set up</h2>
<p>First import the styles into your main SASS file, replacing <code>&lt;path-to-node_modules&gt;</code> with the path to the <em>node_modules</em> directory relative to the file:</p>
<pre><code class="language-scss">@import '&lt;path-to-node_modules&gt;/@potato/ace/components/accordion/accordion';
</code></pre>
<p>Alternatively <em>ace.scss</em> includes all ACE component SASS files, so if using multiple ACE components it can be imported instead:</p>
<pre><code class="language-scss">@import '&lt;path-to-node_modules&gt;/@potato/ace/ace';
</code></pre>
<p>A CSS file is also provided for convenience and is located at <code>&lt;path-to-node_modules&gt;/@potato/ace/components/accordion/ace-accordion.css</code>.</p>
<p>Then import the class into your JavaScript entry point:</p>
<pre><code class="language-js">import '&lt;path-to-node_modules&gt;/@potato/ace/components/accordion/accordion';
</code></pre>
<p>For convenience the ES6 class is exported as <code>Accordion</code> and the attribute names used by the class are exported as properties of <code>ATTRS</code>.</p>
<p>After the event <code>DOMContentLoaded</code> is fired on <code>document</code> an instance of Accordion is instantiated within each <code>&lt;ace-accordion&gt;</code> element and an ID <code>ace-accordion-&lt;n&gt;</code> is added for any instance without one, where <code>&lt;n&gt;</code> is a unique integer. Once instantiation is complete a custom event <code>ace-accordion-ready</code> is dispatched to <code>window</code>. See the <strong>Custom events</strong> section below for more details.</p>
<p>For each section of content Accordion requires a descendant <strong>panel</strong> and a corresponding descendant <strong>header</strong> that in turn contains a child <strong>trigger</strong>. The number of headers, triggers and panels must be the same. Having said this, Accordions can be initalised with none of these, which can instead be added later and initialised by dispatching a custom event. See the <strong>Custom events</strong> section below for more details.</p>
<p>Accordion headers must be HTML heading elements, i.e. <code>&lt;h1&gt;</code>, <code>&lt;h2&gt;</code>, <code>&lt;h3&gt;</code>, <code>&lt;h4&gt;</code>, <code>&lt;h5&gt;</code> or<code>&lt;h6&gt;</code> and of the same type, e.g. all <code>&lt;h3&gt;</code>. Accordion will use all heading elements with attribute <code>ace-accordion-header</code> as long as they are of the same type. If no descendant heading elements have this attribute then all descendant heading elements will be used as headers, as long as they are of the same type, and given this attribute.</p>
<p>Each header must have only a single child element that must also be a <code>&lt;button&gt;</code>, which will be used as the trigger and given the attribute <code>ace-accordion-trigger</code>. Accordion must have a corresponding panel for each trigger element and will use any descendants with attribute <code>ace-accordion-panel</code>. If no descendants have this attribute then all non-heading child elements will be used as panels and given this attribute.</p>
<h2 id="usage">Usage</h2>
<p>The visibility of a panel can be toggled by clicking on it's corresponding trigger button and by default multiple panels can be visible at the same time. Adding attribute <code>ace-accordion-one-visible-panel</code> to the Accordion ensures that only one panel is visible at a time and showing one panel will hide the currently visible panel. By default Accordion initialises with all panels hidden but setting attribute <code>ace-accordion-panel-visible</code> to <code>true</code> on a panel will make that panel visible upon page load.</p>
<h2 id="animating-panels">Animating panels</h2>
<p>Since animations can be achieved using many different methods Accordion does not animate the showing and hiding of panels. Developers interested in doing so can listen for the <code>ace-carousel-panel-visibility-changed</code> custom event and then apply their own animations, as demonstrated in one of the examples below.</p>
<p>In order to implement animations without hindering accessibility developers must hide non-visible panels from screen readers and remove their focusable descendants from the tab sequence after the animation ends, both of which can be achieved by applying CSS declaration <code>display: none</code> or <code>visibility: hidden</code> to them. Furthermore, animations should not be shown to users that have requested the operating system minimise the amount of non-essential motion it uses. To acheive this developers can make use of the <a href="https://developer.mozilla.org/en-US/docs/Web/CSS/@media/prefers-reduced-motion"><code>prefers-reduced-motion</code> media query</a> as demonstrated in the example.</p>
<h2 id="styles">Styles</h2>
<p>The following SASS is applied to Accordion.</p>
<pre><code class="language-scss">[ace-accordion-trigger] {
	width: 100%;
}

[ace-accordion-panel]:not([ace-accordion-panel-visible]) {
	display: none;
}
</code></pre>
<h2 id="custom-events">Custom events</h2>
<p>Accordion uses the following custom events, the names of which are available in its exported <code>EVENTS</code> object, similar to <code>ATTRS</code>, so they may be imported into other modules.</p>
<h3 id="dispatched-events">Dispatched events</h3>
<p>The following events are dispatched to <code>window</code> by Accordion.</p>
<h4 id="ready">Ready</h4>
<p><code>ace-accordion-ready</code></p>
<p>This event is dispatched when Accordion finishes initialising just after page load, and after dynamically added descendants are initialised in response to the <code>ace-accordion-update</code> custom event being dispatched. The event name is available as <code>EVENTS.OUT.READY</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Accordion [string]
}
</code></pre>
<h4 id="panel-visibility-changed">Panel visibility changed</h4>
<p><code>ace-accordion-panel-visibility-changed</code></p>
<p>This event is dispatched when a panel's visiblity changes. The event name is available as <code>EVENTS.OUT.PANEL_VISIBILITY_CHANGED</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Accordion [string]
	'panelNumber': // The number of the panel that changed [number]
	'panelVisible': // Whether the panel is now visible or not [boolean]
}
</code></pre>
<h3 id="listened-for-events">Listened for events</h3>
<p>Accordion listens for the following events that should be dispatched to <code>window</code>.</p>
<h4 id="show%2C-hide-and-toggle-panel">Show, hide and toggle panel</h4>
<p><code>ace-accordion-show-panel</code>, <code>ace-accordion-hide-panel</code> &amp; <code>ace-accordion-toggle-panel</code></p>
<p>These events should be dispatched to show, hide and toggle the visibility of a panel. The event names are available as <code>EVENTS.IN.SHOW_PANEL</code>, <code>EVENTS.IN.HIDE_PANEL</code> and <code>EVENTS.IN.TOGGLE_PANEL</code>, and their <code>detail</code> properties should be composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of target Accordion [string]
	'panelNumber': // The number of the panel to change the visibility of [number]
}
</code></pre>
<h4 id="show-and-hide-all-panels">Show and hide all panels</h4>
<p><code>ace-accordion-show-all-panels</code> &amp; <code>ace-accordion-hide-all-panels</code></p>
<p>These events should be dispatched to show and hide all panels. The event names are available as <code>EVENTS.IN.SHOW_ALL_PANELS</code> and <code>EVENTS.IN.HIDE_ALL_PANELS</code> and their <code>detail</code> properties should be composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of target Accordion [string]
}
</code></pre>
<h4 id="update">Update</h4>
<p><code>ace-accordion-update</code></p>
<p>This event should be dispatched when headers, triggers and panels are added or removed and causes Accordion to initialise them and then dispatch the <code>ace-accordion-ready</code> event. The event name is available as <code>EVENTS.IN.UPDATE</code> and its <code>detail</code> property should be composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of target Accordion [string]
}
</code></pre>
<h2 id="examples">Examples</h2>
<p>Each example contains a live demo and the HTML code that produced it. The code shown may differ slightly to that rendered for the demo as some components may alter their HTML when they initialise.</p>
<h3 id="simple-accordion">Simple Accordion</h3>
<p>Example of a simple Accordion with 3 panels.</p>
<div class="example-block"><ace-accordion>
	<h3>
		<button>Trigger 1</button>
	</h3>
	<div>
		<p>Panel 1 content</p>
	</div>
	<h3>
		<button>Trigger 2</button>
	</h3>
	<div>
		<p>Panel 2 content</p>
	</div>
	<h3>
		<button>Trigger 3</button>
	</h3>
	<div>
		<p>Panel 3 content</p>
	</div>
</ace-accordion>
</div>
<pre><code class="language-html">&lt;ace-accordion&gt;
	&lt;h3&gt;
		&lt;button&gt;Trigger 1&lt;/button&gt;
	&lt;/h3&gt;
	&lt;div&gt;
		&lt;p&gt;Panel 1 content&lt;/p&gt;
	&lt;/div&gt;
	&lt;h3&gt;
		&lt;button&gt;Trigger 2&lt;/button&gt;
	&lt;/h3&gt;
	&lt;div&gt;
		&lt;p&gt;Panel 2 content&lt;/p&gt;
	&lt;/div&gt;
	&lt;h3&gt;
		&lt;button&gt;Trigger 3&lt;/button&gt;
	&lt;/h3&gt;
	&lt;div&gt;
		&lt;p&gt;Panel 3 content&lt;/p&gt;
	&lt;/div&gt;
&lt;/ace-accordion&gt;
</code></pre>
<h3 id="accordion-with-initially-visible-second-panel-and-one-panel-visible-at-a-time">Accordion with initially visible second panel and one panel visible at a time</h3>
<p>This Accordion will show the second panel upon page load as it has the attribute <code>ace-accordion-panel-visible</code> with value <code>true</code>. The Accordion also has the attribute <code>ace-accordion-one-visible-panel</code> so only one panel is visible at a time and showing a panel will hide the currently visible panel.</p>
<div class="example-block"><ace-accordion ace-accordion-one-visible-panel id="ace-one-visible-panel-accordion">
	<h3>
		<button>Trigger 1</button>
	</h3>
	<div>
		<p>Panel 1 content</p>
	</div>
	<h3>
		<button>Trigger 2</button>
	</h3>
	<div ace-accordion-panel-visible="true">
		<p>Panel 2 content</p>
	</div>
	<h3>
		<button>Trigger 3</button>
	</h3>
	<div>
		<p>Panel 3 content</p>
	</div>
</ace-accordion>
</div>
<pre><code class="language-html">&lt;ace-accordion ace-accordion-one-visible-panel id=&quot;ace-one-visible-panel-accordion&quot;&gt;
	&lt;h3&gt;
		&lt;button&gt;Trigger 1&lt;/button&gt;
	&lt;/h3&gt;
	&lt;div&gt;
		&lt;p&gt;Panel 1 content&lt;/p&gt;
	&lt;/div&gt;
	&lt;h3&gt;
		&lt;button&gt;Trigger 2&lt;/button&gt;
	&lt;/h3&gt;
	&lt;div ace-accordion-panel-visible=&quot;true&quot;&gt;
		&lt;p&gt;Panel 2 content&lt;/p&gt;
	&lt;/div&gt;
	&lt;h3&gt;
		&lt;button&gt;Trigger 3&lt;/button&gt;
	&lt;/h3&gt;
	&lt;div&gt;
		&lt;p&gt;Panel 3 content&lt;/p&gt;
	&lt;/div&gt;
&lt;/ace-accordion&gt;
</code></pre>
<h3 id="animated-accordion">Animated Accordion</h3>
<p>Example of how an Accordion can be animated. Custom styles have been applied to this example and are shown below.</p>
<p>Note that this method should only be used if the panels are of the same or similar heights. The reason for this is that the height transitions from 0px to <code>max-height</code> over the transition duration time, therefore <code>max-height</code> must be set to a value that allows the tallest panel to be visible. If one panel is significantly taller than the others the shorter panels have less to reveal during the transition which will therefore seem to take less time than expected as when the panel is fully visible the transition is still ongoing until <code>max-height</code> reaches the value given.</p>
<div class="example-block"><ace-accordion ace-accordion-one-visible-panel class="animated-accordion" id="ace-animated-accordion" >
	<h3>
		<button>Trigger 1</button>
	</h3>
	<div>
		<p>Panel 1 content</p>
		<img src="/img/logo.svg" height="100px" alt="Potato logo"/>
	</div>
	<h3>
		<button>Trigger 2</button>
	</h3>
	<div>
		<p>Panel 2 content</p>
		<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone"/>
	</div>
	<h3>
		<button>Trigger 3</button>
	</h3>
	<div>
		<p>Panel 3 content</p>
		<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles"/>
	</div>
</ace-accordion>
</div>
<pre><code class="language-html">&lt;ace-accordion ace-accordion-one-visible-panel class=&quot;animated-accordion&quot; id=&quot;ace-animated-accordion&quot; &gt;
	&lt;h3&gt;
		&lt;button&gt;Trigger 1&lt;/button&gt;
	&lt;/h3&gt;
	&lt;div&gt;
		&lt;p&gt;Panel 1 content&lt;/p&gt;
		&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot;/&gt;
	&lt;/div&gt;
	&lt;h3&gt;
		&lt;button&gt;Trigger 2&lt;/button&gt;
	&lt;/h3&gt;
	&lt;div&gt;
		&lt;p&gt;Panel 2 content&lt;/p&gt;
		&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot;/&gt;
	&lt;/div&gt;
	&lt;h3&gt;
		&lt;button&gt;Trigger 3&lt;/button&gt;
	&lt;/h3&gt;
	&lt;div&gt;
		&lt;p&gt;Panel 3 content&lt;/p&gt;
		&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot;/&gt;
	&lt;/div&gt;
&lt;/ace-accordion&gt;
</code></pre>
<pre><code class="language-scss">.animated-accordion {
	@media (prefers-reduced-motion: no-preference) {
		$trans-duration: .2s;

		[ace-accordion-panel] {
			display: block;
			max-height: 0;
			overflow: hidden;
			transition: max-height $trans-duration ease-out, visibility 0s linear $trans-duration;
			visibility: hidden;
		}

		[ace-accordion-panel-visible] {
			max-height: 180px;
			transition: max-height $trans-duration ease-in;
			visibility: visible;
		}
	}
}
</code></pre>
<h3 id="accordion-controlled-through-custom-events">Accordion controlled through custom events</h3>
<p>The JavaScript used by this example is shown below.</p>
<div class="example-block"><label>
	Panel number:
	<input id="panel-number" type="number" min="1" max="3" />
</label>
<button id="toggle-panel-btn">Toggle panel</button>
<button id="show-panel-btn">Show panel</button>
<button id="hide-panel-btn">Hide panel</button>
<hr>
<button id="show-panels-btn">Show all panels</button>
<button id="hide-panels-btn">Hide all panels</button>
<hr>
<button id="append-panel-btn">Append panel</button>
<button id="remove-panel-btn">Remove first panel</button>
<hr>
<ace-accordion id="ace-custom-events-accordion">
	<h3>
		<button>Trigger 1</button>
	</h3>
	<div>
		<p>Panel 1 content</p>
	</div>
	<h3>
		<button>Trigger 2</button>
	</h3>
	<div>
		<p>Panel 2 content</p>
	</div>
	<h3>
		<button>Trigger 3</button>
	</h3>
	<div>
		<p>Panel 3 content</p>
	</div>
</ace-accordion>
</div>
<pre><code class="language-html">&lt;label&gt;
	Panel number:
	&lt;input id=&quot;panel-number&quot; type=&quot;number&quot; min=&quot;1&quot; max=&quot;3&quot; /&gt;
&lt;/label&gt;
&lt;button id=&quot;toggle-panel-btn&quot;&gt;Toggle panel&lt;/button&gt;
&lt;button id=&quot;show-panel-btn&quot;&gt;Show panel&lt;/button&gt;
&lt;button id=&quot;hide-panel-btn&quot;&gt;Hide panel&lt;/button&gt;
&lt;hr&gt;
&lt;button id=&quot;show-panels-btn&quot;&gt;Show all panels&lt;/button&gt;
&lt;button id=&quot;hide-panels-btn&quot;&gt;Hide all panels&lt;/button&gt;
&lt;hr&gt;
&lt;button id=&quot;append-panel-btn&quot;&gt;Append panel&lt;/button&gt;
&lt;button id=&quot;remove-panel-btn&quot;&gt;Remove first panel&lt;/button&gt;
&lt;hr&gt;

&lt;ace-accordion id=&quot;ace-custom-events-accordion&quot;&gt;
	&lt;h3&gt;
		&lt;button&gt;Trigger 1&lt;/button&gt;
	&lt;/h3&gt;
	&lt;div&gt;
		&lt;p&gt;Panel 1 content&lt;/p&gt;
	&lt;/div&gt;
	&lt;h3&gt;
		&lt;button&gt;Trigger 2&lt;/button&gt;
	&lt;/h3&gt;
	&lt;div&gt;
		&lt;p&gt;Panel 2 content&lt;/p&gt;
	&lt;/div&gt;
	&lt;h3&gt;
		&lt;button&gt;Trigger 3&lt;/button&gt;
	&lt;/h3&gt;
	&lt;div&gt;
		&lt;p&gt;Panel 3 content&lt;/p&gt;
	&lt;/div&gt;
&lt;/ace-accordion&gt;
</code></pre>
<pre><code class="language-js">import {ATTRS, EVENTS} from '/ace/components/accordion/accordion.js';

document.addEventListener('DOMContentLoaded', () =&gt; {
	const ACCORDION_ID = 'ace-custom-events-accordion';
	const accordionEl = document.getElementById(ACCORDION_ID);

	window.addEventListener('click', (e) =&gt; {
		const targetId = e.target.id;
		switch(targetId) {
			case 'hide-panel-btn':
			case 'show-panel-btn':
			case 'toggle-panel-btn': {
				let customEvent;
				const panelNumber = document.getElementById('panel-number').value;
				if (targetId === 'toggle-panel-btn') {
					customEvent = EVENTS.IN.TOGGLE_PANEL;
				} else {
					customEvent = EVENTS.IN[`${targetId === 'hide-panel-btn' ? 'HIDE' : 'SHOW'}_PANEL`];
				}
				window.dispatchEvent(new CustomEvent(
					customEvent,
					{
						'detail': {
							'id': ACCORDION_ID,
							'panelNumber': panelNumber,
						}
					}
				));
				break;
			}
			case 'show-panels-btn':
			case 'hide-panels-btn': {
				const customEvent = EVENTS.IN[`${targetId === 'hide-panels-btn' ? 'HIDE' : 'SHOW'}_ALL_PANELS`];
				window.dispatchEvent(new CustomEvent(
					customEvent,
					{'detail': {'id': ACCORDION_ID}},
				));
				break;
			}
			case 'append-panel-btn': {
				const newTriggerEl = document.createElement('button');
				newTriggerEl.textContent = 'Dynamically added trigger';
				const newHeaderEl = document.createElement('h3');
				newHeaderEl.setAttribute(ATTRS.HEADER, '');
				newHeaderEl.append(newTriggerEl);

				const newPanelP = document.createElement('p');
				newPanelP.textContent = `Dynamically added panel`;
				const newPanelEl = document.createElement('div');
				newPanelEl.setAttribute(ATTRS.PANEL, '');
				newPanelEl.append(newPanelP);

				accordionEl.append(newHeaderEl);
				accordionEl.append(newPanelEl);
				window.dispatchEvent(new CustomEvent(
					EVENTS.IN.UPDATE,
					{'detail': {'id': ACCORDION_ID}},
				));
				break;
			}
			case 'remove-panel-btn': {
				const headerEl = accordionEl.querySelector(`[${ATTRS.HEADER}]`);
				const panelEl = accordionEl.querySelector(`[${ATTRS.PANEL}]`);
				accordionEl.removeChild(headerEl);
				accordionEl.removeChild(panelEl);
				window.dispatchEvent(new CustomEvent(
					EVENTS.IN.UPDATE,
					{'detail': {'id': ACCORDION_ID}},
				));
				break;
			}
		}
	});
});
</code></pre>
<h3 id="styled-accordion">Styled Accordion</h3>
<p>An example of how Accordion can be styled to resemble a commonly used design. Custom styles have been applied to this example and are shown below.</p>
<div class="example-block"><h2>Potato</h2>
<p>Things we do at Potato:</p>
<ace-accordion class="styled-accordion">
	<h3 class="styled-accordion__header">
		<button class="styled-accordion__trigger">
			Making new tech count
		</button>
	</h3>
	<div class="styled-accordion__panel">
		<div class="styled-accordion__panel-inner">
			<p>
				It’s the positive and transformative effects of technology that matter, not the technology itself.
			</p>
			<p>
				<a href="https://p.ota.to/work/making-new-tech-count" target="_blank">
					Find out more
				</a>
			</p>
			<img src="/img/logo.svg" height="100px" alt="Potato logo"/>
		</div>
	</div>
	<h3 class="styled-accordion__header">
		<button class="styled-accordion__trigger">
			Making digital for real life
		</button>
	</h3>
	<div class="styled-accordion__panel">
		<div class="styled-accordion__panel-inner">
			<p>
				People value digital products that enhance their lives and positively complement their interactions with the world.
			</p>
			<p>
				<a href="https://p.ota.to/work/making-digital-for-real-life" target="_blank">
					Find out more
				</a>
			</p>
			<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone"/>
		</div>
	</div>
	<h3 class="styled-accordion__header">
		<button class="styled-accordion__trigger">
			Building for people first
		</button>
	</h3>
	<div class="styled-accordion__panel">
		<div class="styled-accordion__panel-inner">
			<p>
				Gaining direct insight through testing products with people is the fundamental requirement to make things better.
			</p>
			<p>
				<a href="https://p.ota.to/work/building-for-people-first" target="_blank">
					Find out more
				</a>
			</p>
			<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles"/>
		</div>
	</div>
</ace-accordion>
</div>
<pre><code class="language-html">&lt;h2&gt;Potato&lt;/h2&gt;
&lt;p&gt;Things we do at Potato:&lt;/p&gt;

&lt;ace-accordion class=&quot;styled-accordion&quot;&gt;
	&lt;h3 class=&quot;styled-accordion__header&quot;&gt;
		&lt;button class=&quot;styled-accordion__trigger&quot;&gt;
			Making new tech count
		&lt;/button&gt;
	&lt;/h3&gt;
	&lt;div class=&quot;styled-accordion__panel&quot;&gt;
		&lt;div class=&quot;styled-accordion__panel-inner&quot;&gt;
			&lt;p&gt;
				It’s the positive and transformative effects of technology that matter, not the technology itself.
			&lt;/p&gt;
			&lt;p&gt;
				&lt;a href=&quot;https://p.ota.to/work/making-new-tech-count&quot; target=&quot;_blank&quot;&gt;
					Find out more
				&lt;/a&gt;
			&lt;/p&gt;
			&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot;/&gt;
		&lt;/div&gt;
	&lt;/div&gt;
	&lt;h3 class=&quot;styled-accordion__header&quot;&gt;
		&lt;button class=&quot;styled-accordion__trigger&quot;&gt;
			Making digital for real life
		&lt;/button&gt;
	&lt;/h3&gt;
	&lt;div class=&quot;styled-accordion__panel&quot;&gt;
		&lt;div class=&quot;styled-accordion__panel-inner&quot;&gt;
			&lt;p&gt;
				People value digital products that enhance their lives and positively complement their interactions with the world.
			&lt;/p&gt;
			&lt;p&gt;
				&lt;a href=&quot;https://p.ota.to/work/making-digital-for-real-life&quot; target=&quot;_blank&quot;&gt;
					Find out more
				&lt;/a&gt;
			&lt;/p&gt;
			&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot;/&gt;
		&lt;/div&gt;
	&lt;/div&gt;
	&lt;h3 class=&quot;styled-accordion__header&quot;&gt;
		&lt;button class=&quot;styled-accordion__trigger&quot;&gt;
			Building for people first
		&lt;/button&gt;
	&lt;/h3&gt;
	&lt;div class=&quot;styled-accordion__panel&quot;&gt;
		&lt;div class=&quot;styled-accordion__panel-inner&quot;&gt;
			&lt;p&gt;
				Gaining direct insight through testing products with people is the fundamental requirement to make things better.
			&lt;/p&gt;
			&lt;p&gt;
				&lt;a href=&quot;https://p.ota.to/work/building-for-people-first&quot; target=&quot;_blank&quot;&gt;
					Find out more
				&lt;/a&gt;
			&lt;/p&gt;
			&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot;/&gt;
		&lt;/div&gt;
	&lt;/div&gt;
&lt;/ace-accordion&gt;
</code></pre>
<pre><code class="language-scss">.styled-accordion {
	$trans-duration: .2s;

	border: 1px solid black;
	border-radius: 10px;
	display: block;
	max-width: 500px;
	overflow: hidden;

	&amp;__header {
		margin: 0;

		&amp;:not(:first-child) {
			border-top: 1px solid black;
		}
	}

	&amp;__trigger {
		background: #41354d;
		border: 0;
		color: #fff;
		display: flex;
		font-weight: 600;
		justify-content: space-between;
		padding: 20px;
		width: 100%;

		&amp;::after {
			content: '\25BC';

			@media (prefers-reduced-motion: no-preference) {
				transition: transform $trans-duration linear;
			}
		}

		&amp;[aria-expanded=&quot;true&quot;] {
			&amp;::after {
				transform: rotate(180deg);
			}
		}
	}

	&amp;__panel {
		@media (prefers-reduced-motion: no-preference) {
			max-height: 0;
			overflow: hidden;
			transition: max-height $trans-duration ease-out, visibility 0s linear $trans-duration;
			visibility: hidden;

			&amp;:not([ace-accordion-panel-visible]) {
				display: block;
			}
		}
	}

	[ace-accordion-panel-visible] {
		@media (prefers-reduced-motion: no-preference) {
			max-height: 300px;
			transition: max-height $trans-duration ease-in;
			visibility: visible;
		}
	}

	&amp;__panel-inner {
		padding: 10px 20px;
	}
}
</code></pre>
